Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.value
Class DateValue

    java.lang.Object
      net.sf.saxon.value.Value<AtomicValue>
          net.sf.saxon.value.AtomicValue
              net.sf.saxon.value.CalendarValue
                  net.sf.saxon.value.GDateValue
                      net.sf.saxon.value.DateValue

All Implemented Interfaces:
  Comparable, PullEvent, GroundedValue<AtomicValue>, Item<AtomicValue>, ValueRepresentation<AtomicValue>, ConversionResult

    public class DateValue

extends GDateValue
implements Comparable

A value of type Date. Note that a Date may include a TimeZone.

Field Summary

Fields inherited from class net.sf.saxon.value.GDateValue
`day, daysPerMonth, month, monthData, xsd10rules, year`

Fields inherited from class net.sf.saxon.value.CalendarValue
`NO_TIMEZONE`

Fields inherited from class net.sf.saxon.value.AtomicValue
`typeLabel`

Fields inherited from class net.sf.saxon.value.Value
`INDETERMINATE_ORDERING`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`DateValue(CharSequence s)` Constructor: create a date value from a supplied string, in ISO 8601 format
`DateValue(CharSequence s, ConversionRules rules)` Constructor: create a date value from a supplied string, in ISO 8601 format
`DateValue(GregorianCalendar calendar, int tz)` Create a DateValue
`DateValue(int year, byte month, byte day)` Constructor given a year, month, and day.
`DateValue(int year, byte month, byte day, boolean xsd10)` Constructor given a year, month, day and xsd10.
`DateValue(int year, byte month, byte day, int tz, AtomicType type)` Constructor given a year, month, and day, and timezone, and an AtomicType representing a subtype of xs:date.
`DateValue(int year, byte month, byte day, int tz, boolean xsd10)` Constructor given a year, month, and day, and timezone.

Method Summary
`CalendarValue` | `add(DurationValue duration)` Add a duration to a date
`CalendarValue` | `adjustTimezone(int timezone)` Return a new date with the same normalized value, but in a different timezone.
`int` | `compareTo(Object v2)` Context-free comparison of two DateValue values.
`AtomicValue` | `copyAsSubType(AtomicType typeLabel)` Make a copy of this date value, but with a new type label
`static DateValue` | `dateFromJulianDayNumber(int julianDayNumber)` Get the Gregorian date corresponding to a particular Julian day number.
`CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
`static int` | `getDayOfWeek(int year, int month, int day)` Get the day of the week.
`static int` | `getDayWithinYear(int year, int month, int day)` Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)
`int` | `getJulianDayNumber()` Calculate the Julian day number at 00:00 on this date.
`static int` | `getJulianDayNumber(int year, int month, int day)` Calculate the Julian day number at 00:00 on a given date.
`CharSequence` | `getPrimitiveStringValue()` Convert to string
`BuiltInAtomicType` | `getPrimitiveType()` Determine the primitive type of the value.
`static int` | `getWeekNumber(int year, int month, int day)` Get the ISO week number for a given date.
`static int` | `getWeekNumberWithinMonth(int year, int month, int day)` Get the week number within a month.
`static ConversionResult` | `makeDateValue(CharSequence in, ConversionRules rules)` Static factory method: construct a DateValue from a string in the lexical form of a date, returning a ValidationFailure if the supplied string is invalid
`DayTimeDurationValue` | `subtract(CalendarValue other, XPathContext context)` Determine the difference between two points in time, as a duration
`static DateValue` | `tomorrow(int year, byte month, byte day)` Get the date that immediately follows a given date
`static DateValue` | `yesterday(int year, byte month, byte day)` Get the date that immediately precedes a given date

Methods inherited from class net.sf.saxon.value.GDateValue
`compareTo, equals, getCalendar, getComparisonKey, getComponent, getDay, getMonth, getSchemaComparable, getYear, hashCode, isLeapYear, isValidDate, setLexicalValue, toDateTime`

Methods inherited from class net.sf.saxon.value.CalendarValue
`adjustTimezone, appendTimezone, appendTimezone, getTimezoneInMinutes, getXPathComparable, hasTimezone, isIdentical, makeCalendarValue, removeTimezone, setTimezoneInMinutes`

Methods inherited from class net.sf.saxon.value.AtomicValue
`asAtomic, checkPermittedContents, effectiveBooleanValue, getCardinality, getItemType, getLength, getStringValue, getStringValueCS, getTypedValue, getTypeLabel, isNaN, itemAt, iterate, process, setTypeLabel, subsequence, toString`

Methods inherited from class net.sf.saxon.value.Value
`asItem, asItem, asIterator, asValue, convertToJava, fromItem, getIterator, getSequenceLength, reduce`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day)

  Constructor given a year, month, and day. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is supplied as 0, but will be displayed on output as -0001)
    `month` - The month, 1-12
    `day` - The day, 1-31

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     boolean xsd10)

  Constructor given a year, month, day and xsd10. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is supplied as 0)
    `month` - The month, 1-12
    `day` - The day, 1-31
    `xsd10` - Schema version flag. If set to true, the year before 1AD is displayed as -0001; if false, it is displayed as 0000; but in both cases, it is held internally as zero. The flag makes no difference to dates later than 1AD.

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     int tz,
                     boolean xsd10)

  Constructor given a year, month, and day, and timezone. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is 0)
    `month` - The month, 1-12
    `day` - The day, 1-31
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.
    `xsd10` - Schema version flag. If set to true, the year before 1AD is displayed as -0001; if false, it is displayed as 0000; but in both cases, it is held internally as zero. The flag makes no difference to dates later than 1AD.

### DateValue

    public DateValue(int year,
                     byte month,
                     byte day,
                     int tz,
                     AtomicType type)

  Constructor given a year, month, and day, and timezone, and an AtomicType representing a subtype of xs:date. Performs no validation.

  Parameters:
    `year` - The year as held internally (note that the year before 1AD is 0)
    `month` - The month, 1-12
    `day` - The day 1-31
    `tz` - the timezone displacement in minutes from UTC. Supply the value `CalendarValue.NO_TIMEZONE` if there is no timezone component.
    `type` - the type. This must be a type derived from xs:date, and the value must conform to this type. The method does not check these conditions.

### DateValue

    public DateValue(CharSequence s)
              throws ValidationException

  Constructor: create a date value from a supplied string, in ISO 8601 format

  Parameters:
    `s` - the lexical form of the date value. Currently this assumes XSD 1.0 conventions for BC years (that is, no year zero), but this may change at some time.
  Throws:
    `ValidationException` - if the supplied string is not a valid date

### DateValue

    public DateValue(CharSequence s,
                     ConversionRules rules)
              throws ValidationException

  Constructor: create a date value from a supplied string, in ISO 8601 format

  Parameters:
    `s` - the lexical form of the date value
    `rules` - the conversion rules (determining whether year zero is allowed)
  Throws:
    `ValidationException` - if the supplied string is not a valid date

### DateValue

    public DateValue(GregorianCalendar calendar,
                     int tz)

  Create a DateValue

  Parameters:
    `calendar` - the absolute date/time value
    `tz` - The timezone offset from GMT in minutes, positive or negative; or the special value NO_TIMEZONE indicating that the value is not in a timezone

Method Detail

### makeDateValue

    public static ConversionResult makeDateValue(CharSequence in,
                                                 ConversionRules rules)

  Static factory method: construct a DateValue from a string in the lexical form of a date, returning a ValidationFailure if the supplied string is invalid

  Parameters:
    `in` - the lexical form of the date
    `rules` -
  Returns:
    either a DateValue or a ValidationFailure

### getPrimitiveType

    public BuiltInAtomicType getPrimitiveType()

  Determine the primitive type of the value. This delivers the same answer as getItemType().getPrimitiveItemType(). The primitive types are the 19 primitive types of XML Schema, plus xs:integer, xs:dayTimeDuration and xs:yearMonthDuration, and xs:untypedAtomic. For external objects, the result is AnyAtomicType.

  Specified by:
    `getPrimitiveType` in class `AtomicValue`
  Returns:
    the primitive type

### tomorrow

    public static DateValue tomorrow(int year,
                                     byte month,
                                     byte day)

  Get the date that immediately follows a given date

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    a new DateValue with no timezone information

### yesterday

    public static DateValue yesterday(int year,
                                      byte month,
                                      byte day)

  Get the date that immediately precedes a given date

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    a new DateValue with no timezone information

### getPrimitiveStringValue

    public CharSequence getPrimitiveStringValue()

  Convert to string

  Specified by:
    `getPrimitiveStringValue` in class `AtomicValue`
  Returns:
    ISO 8601 representation.

### getCanonicalLexicalRepresentation

    public CharSequence getCanonicalLexicalRepresentation()

  Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules. For xs:date, the timezone is adjusted to be in the range +12:00 to -11:59

  Overrides:
    `getCanonicalLexicalRepresentation` in class `Value<AtomicValue>`
  Returns:
    the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

### copyAsSubType

    public AtomicValue copyAsSubType(AtomicType typeLabel)

  Make a copy of this date value, but with a new type label

  Specified by:
    `copyAsSubType` in class `AtomicValue`
  Parameters:
    `typeLabel` - the new type label: must be a subtype of xs:date
  Returns:
    the new xs:date value

### adjustTimezone

    public CalendarValue adjustTimezone(int timezone)

  Return a new date with the same normalized value, but in a different timezone. This is called only for a DateValue that has an explicit timezone

  Specified by:
    `adjustTimezone` in class `CalendarValue`
  Parameters:
    `timezone` - the new timezone offset, in minutes
  Returns:
    the time in the new timezone. This will be a new TimeValue unless no change was required to the original value

### add

    public CalendarValue add(DurationValue duration)
                      throws XPathException

  Add a duration to a date

  Specified by:
    `add` in class `CalendarValue`
  Parameters:
    `duration` - the duration to be added (may be negative)
  Returns:
    the new date
  Throws:
    `XPathException` - if the duration is an xs:duration, as distinct from a subclass thereof

### subtract

    public DayTimeDurationValue subtract(CalendarValue other,
                                         XPathContext context)
                                  throws XPathException

  Determine the difference between two points in time, as a duration

  Overrides:
    `subtract` in class `CalendarValue`
  Parameters:
    `other` - the other point in time
    `context` - the XPath dynamic context. May be set to null only if both values contain an explicit timezone, or if neither does so.
  Returns:
    the duration as an xs:dayTimeDuration
  Throws:
    `XPathException` - for example if one value is a date and the other is a time

### compareTo

    public int compareTo(Object v2)

  Context-free comparison of two DateValue values. For this to work, the two values must either both have a timezone or both have none.

  Specified by:
    `compareTo` in interface `Comparable`
  Parameters:
    `v2` - the other value
  Returns:
    the result of the comparison: -1 if the first is earlier, 0 if they are equal, +1 if the first is later
  Throws:
    `ClassCastException` - if the values are not comparable (which might be because no timezone is available)

### getJulianDayNumber

    public static int getJulianDayNumber(int year,
                                         int month,
                                         int day)

  Calculate the Julian day number at 00:00 on a given date. This algorithm is taken from http://vsg.cape.com/~pbaum/date/jdalg.htm and http://vsg.cape.com/~pbaum/date/jdalg2.htm (adjusted to handle BC dates correctly)

  Note that this assumes dates in the proleptic Gregorian calendar

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    the Julian day number

### getJulianDayNumber

    public int getJulianDayNumber()

  Calculate the Julian day number at 00:00 on this date.

  Note that this assumes dates in the proleptic Gregorian calendar

  Returns:
    the Julian day number

### dateFromJulianDayNumber

    public static DateValue dateFromJulianDayNumber(int julianDayNumber)

  Get the Gregorian date corresponding to a particular Julian day number. The algorithm is taken from http://www.hermetic.ch/cal_stud/jdn.htm#comp

  Parameters:
    `julianDayNumber` - the Julian day number
  Returns:
    a DateValue with no timezone information set

### getDayWithinYear

    public static int getDayWithinYear(int year,
                                       int month,
                                       int day)

  Get the ordinal day number within the year (1 Jan = 1, 1 Feb = 32, etc)

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    the ordinal day number within the year

### getDayOfWeek

    public static int getDayOfWeek(int year,
                                   int month,
                                   int day)

  Get the day of the week. The days of the week are numbered from 1 (Monday) to 7 (Sunday)

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    the day of the week, 1=Monday .... 7=Sunday

### getWeekNumber

    public static int getWeekNumber(int year,
                                    int month,
                                    int day)

  Get the ISO week number for a given date. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and week 1 in any calendar year is the week (from Monday to Sunday) that includes the first Thursday of that year

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    the ISO week number

### getWeekNumberWithinMonth

    public static int getWeekNumberWithinMonth(int year,
                                               int month,
                                               int day)

  Get the week number within a month. This is required for the XSLT format-date() function, and the rules are not entirely clear. The days of the week are numbered from 1 (Monday) to 7 (Sunday), and by analogy with the ISO week number, we consider that week 1 in any calendar month is the week (from Monday to Sunday) that includes the first Thursday of that month. Unlike the ISO week number, we put the previous days in week zero.

  Parameters:
    `year` - the year
    `month` - the month (1-12)
    `day` - the day (1-31)
  Returns:
    the week number within a month

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.